﻿using System;
using System.Net;
using System.Net.Sockets;
using System.Text;
using System.Threading;

namespace MySocket.Demo.Server
{
    internal class Program
    {
        private static void Main(string[] args)
        {
            var socketHandle = (IntPtr) Convert.ToInt32(args[0]);
            var index = args[1];
            Console.WriteLine(index + "-Server启动");
            var mysocket = new DotNet.Net.MySocket();
            while (true)
            {
                try
                {
                    var handler = mysocket.Accept(socketHandle, new IPEndPoint(IPAddress.Any, 8888));
                    var tMain = new Thread(MainThread) {IsBackground = true};
                    tMain.Start(new object[]{handler, index});
                }
                catch (Exception er)
                {
                    Console.WriteLine(er.Message);
                    Thread.Sleep(2000);
                }
            }
        }

        private static void MainThread(object sender)
        {
            var handler = (DotNet.Net.MySocket) ((object[])sender)[0];
            var index = (string) ((object[])sender)[1];
            var buffer = new byte[8192];
            var message = "";
            while (true)
            {
                try
                {
                    var l = handler.Receive(buffer, 0, buffer.Length, SocketFlags.None);
                    if (l == 0)
                        break;
                    message += Encoding.UTF8.GetString(buffer, 0, l);
                }
                catch (SocketException)
                {
                    break;
                }
            }
            Console.WriteLine("{0} {1}-Server 收到：{2}", DateTime.Now.ToString("HH:mm:ss fff"), index, message);
        }
    }
}
